CREATE OR REPLACE FUNCTION ARQUIVO_GIM_RN_20(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_CONTADOR     IN NUMBER) RETURN VARCHAR
AS
   V_DADOS               VARCHAR2(4000);
   V_CDIMPOSTRIB         VARCHAR2(02);
   V_CONTADOR            NUMBER;
   V_VRTOTAIMPOS         NUMBER;
   V_VRIMPSUBST          NUMBER;
   V_DATAINICIAL         DATE;
   V_DATAFIM             DATE;
   V_TOTVRTRIBUTADO      NUMBER;
   V_VRTRIBUTADOFIM      NUMBER;
   V_VRTRIBUTADO         NUMBER;
   V_TOTVRTRIBUTADOFIM   NUMBER;
   V_POS_LINHA           NUMBER;

BEGIN
   V_CONTADOR := P_CONTADOR;

   V_DATAINICIAL := TO_DATE('01/01/'||ABS(1 - SUBSTR(P_DTINICIAL,7,10)));
   V_DATAFIM     := TO_DATE('31/12/'||ABS(1 - SUBSTR(P_DTFINAL,7,10)));

   FOR C_FILIAL IN(SELECT F.CDFILIAL, F.CDINSCESTA
                   FROM FILIAL F
                   WHERE F.CDEMPRESA = P_CDEMPRESA
                     AND F.CDINSCESTA = P_CDINSCESTA)  LOOP

      /*ESTOQUE INICIAL DOS PRODUTOS */
      BEGIN
         SELECT SUM(DECODE(CDFISCAL,'1',VRESTDIACON,0))
           INTO V_VRTRIBUTADO
           FROM (SELECT I.VRTOTINVFISC AS VRESTDIACON,
                     CODIGO_FISCAL_PRODUTO_NFE('E',P_CDEMPRESA,P.CDPRODUTO,C_FILIAL.CDINSCESTA,'01',P_CDIMPOSTO) AS CDFISCAL
                FROM INVENTFISC I, PRODUTO P
                  WHERE I.CDEMPRESA    = P_CDEMPRESA
                    AND I.CDINSCESTA   = C_FILIAL.CDINSCESTA
                    AND I.CDPRODUTO    = P.CDPRODUTO
                    AND I.QTESTINVFISC <> 0
                    AND I.DTINVEFISCAL = (SELECT MAX(DTINVEFISCAL)
                                             FROM INVENTFISC V  , PRODUTO PR
                                            WHERE V.DTINVEFISCAL <= TO_DATE('31/12/'||(TO_CHAR(V_DATAINICIAL,'YYYY')-1))
                                             AND V.CDEMPRESA = P_CDEMPRESA
                                             AND V.CDINSCESTA   = C_FILIAL.CDINSCESTA
                                             AND V.CDPRODUTO    = PR.CDPRODUTO
                                             AND V.QTESTINVFISC <> 0));

      EXCEPTION WHEN NO_DATA_FOUND THEN
          V_VRTRIBUTADO  := LPAD(0,14,0);
      END;
      V_TOTVRTRIBUTADO  := V_TOTVRTRIBUTADO + NVL(V_VRTRIBUTADO,0);

     /*ESTOQUE FINAL DOS PRODUTOS */
      BEGIN
         SELECT SUM(DECODE(CDFISCAL,'1',VRESTDIACON,0))
           INTO V_VRTRIBUTADOFIM
           FROM (SELECT I.VRTOTINVFISC AS VRESTDIACON,
                     CODIGO_FISCAL_PRODUTO_NFE('E',P_CDEMPRESA,P.CDPRODUTO,C_FILIAL.CDINSCESTA,'01',P_CDIMPOSTO) AS CDFISCAL
                FROM INVENTFISC I, PRODUTO P
                  WHERE I.CDEMPRESA    = P_CDEMPRESA
                    AND I.CDINSCESTA   = C_FILIAL.CDINSCESTA
                    AND I.CDPRODUTO    = P.CDPRODUTO
                    AND I.QTESTINVFISC <> 0
                    AND I.DTINVEFISCAL = (SELECT MAX(DTINVEFISCAL)
                                             FROM INVENTFISC V  , PRODUTO PR
                                            WHERE V.DTINVEFISCAL <= V_DATAFIM + 1
                                             AND V.CDEMPRESA = P_CDEMPRESA
                                             AND V.CDINSCESTA   = C_FILIAL.CDINSCESTA
                                             AND V.CDPRODUTO    = PR.CDPRODUTO
                                             AND V.QTESTINVFISC <> 0));

      EXCEPTION WHEN NO_DATA_FOUND THEN
          V_VRTRIBUTADOFIM  := LPAD(0,14,0);
      END;
      V_TOTVRTRIBUTADOFIM  := V_TOTVRTRIBUTADOFIM + NVL(V_VRTRIBUTADOFIM,0);
   END LOOP;

   V_DADOS := TO_CHAR(P_DTINICIAL, 'MM')||
              TO_CHAR(P_DTINICIAL, 'YYYY')||
              LPAD(REPLACE(LTRIM(TO_CHAR(NVL(V_TOTVRTRIBUTADO,0)+NVL(V_TOTVRTRIBUTADOFIM,0), '999999999990.00')), '.', ''), 14, '0');

   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD('20',10,'0'), V_DADOS, P_NRSEQARQMAG);


   /********************************* detalhamentos dos dbitos e crditos **********************************************/

   /* outros debitos */
   V_POS_LINHA := 43;
   FOR C_OUTROS_DEB IN (SELECT LPAD(REPLACE(LTRIM(TO_CHAR(NVL(VRITEMMAPR,0), '999999999990.00')), '.', ''), 14, '0') AS VRITEMMAPR,
                               RPAD(SUBSTR(NVL(DSITEMMAPR,' '),1,30), 30, ' ') AS DSITEMMAPR
                        FROM ITMAPARECUP IT, MAPARECUP MR, MAPAAPURAC M
                        WHERE M.NRSEQUMAPAPU = MR.NRSEQUMAPAPU
                          AND MR.NRSEQUMAPAPU = IT.NRSEQUMAPAPU
                          AND M.CDEMPRESA = P_CDEMPRESA
                          AND M.CDINSCESTA = P_CDINSCESTA
                          AND M.DTINIPERIODO = P_DTINICIAL
                          AND M.DTFIMPERIODO = P_DTFINAL
                          AND M.CDIMPOSTO = P_CDIMPOSTO
                          AND IDTIPOITMAPR = 'OD') LOOP

      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD('21'||V_POS_LINHA,10,'0'), TO_CHAR(V_POS_LINHA)||C_OUTROS_DEB.DSITEMMAPR||C_OUTROS_DEB.VRITEMMAPR, P_NRSEQARQMAG);
      V_POS_LINHA := NVL(V_POS_LINHA,0)+1;
   END LOOP;

   /* outros creditos */
   V_POS_LINHA := 48;
   FOR C_OUTROS_DEB IN (SELECT LPAD(REPLACE(LTRIM(TO_CHAR(NVL(VRITEMMAPR,0), '999999999990.00')), '.', ''), 14, '0') AS VRITEMMAPR,
                               RPAD(SUBSTR(NVL(DSITEMMAPR,' '),1,30), 30, ' ') AS DSITEMMAPR
                        FROM ITMAPARECUP IT, MAPARECUP MR, MAPAAPURAC M
                        WHERE M.NRSEQUMAPAPU = MR.NRSEQUMAPAPU
                          AND MR.NRSEQUMAPAPU = IT.NRSEQUMAPAPU
                          AND M.CDEMPRESA = P_CDEMPRESA
                          AND M.CDINSCESTA = P_CDINSCESTA
                          AND M.DTINIPERIODO = P_DTINICIAL
                          AND M.DTFIMPERIODO = P_DTFINAL
                          AND M.CDIMPOSTO = P_CDIMPOSTO
                          AND IDTIPOITMAPR = 'OC') LOOP

      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD('21'||V_POS_LINHA,10,'0'), TO_CHAR(V_POS_LINHA)||C_OUTROS_DEB.DSITEMMAPR||C_OUTROS_DEB.VRITEMMAPR, P_NRSEQARQMAG);
      V_POS_LINHA := NVL(V_POS_LINHA,0)+1;
   END LOOP;

   /* estorno de credito */
   V_POS_LINHA := 58;
   FOR C_OUTROS_DEB IN (SELECT LPAD(REPLACE(LTRIM(TO_CHAR(NVL(VRITEMMAPR,0), '999999999990.00')), '.', ''), 14, '0') AS VRITEMMAPR,
                               RPAD(SUBSTR(NVL(DSITEMMAPR,' '),1,30), 30, ' ') AS DSITEMMAPR
                        FROM ITMAPARECUP IT, MAPARECUP MR, MAPAAPURAC M
                        WHERE M.NRSEQUMAPAPU = MR.NRSEQUMAPAPU
                          AND MR.NRSEQUMAPAPU = IT.NRSEQUMAPAPU
                          AND M.CDEMPRESA = P_CDEMPRESA
                          AND M.CDINSCESTA = P_CDINSCESTA
                          AND M.DTINIPERIODO = P_DTINICIAL
                          AND M.DTFIMPERIODO = P_DTFINAL
                          AND M.CDIMPOSTO = P_CDIMPOSTO
                          AND IDTIPOITMAPR = 'EC') LOOP

      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD('21'||V_POS_LINHA,10,'0'), TO_CHAR(V_POS_LINHA)||C_OUTROS_DEB.DSITEMMAPR||C_OUTROS_DEB.VRITEMMAPR, P_NRSEQARQMAG);
      V_POS_LINHA := NVL(V_POS_LINHA,0)+1;
   END LOOP;

   /* estorno de debito */
   V_POS_LINHA := 63;
   FOR C_OUTROS_DEB IN (SELECT LPAD(REPLACE(LTRIM(TO_CHAR(NVL(VRITEMMAPR,0), '999999999990.00')), '.', ''), 14, '0') AS VRITEMMAPR,
                               RPAD(SUBSTR(NVL(DSITEMMAPR,' '),1,30), 30, ' ') AS DSITEMMAPR
                        FROM ITMAPARECUP IT, MAPARECUP MR, MAPAAPURAC M
                        WHERE M.NRSEQUMAPAPU = MR.NRSEQUMAPAPU
                          AND MR.NRSEQUMAPAPU = IT.NRSEQUMAPAPU
                          AND M.CDEMPRESA = P_CDEMPRESA
                          AND M.CDINSCESTA = P_CDINSCESTA
                          AND M.DTINIPERIODO = P_DTINICIAL
                          AND M.DTFIMPERIODO = P_DTFINAL
                          AND M.CDIMPOSTO = P_CDIMPOSTO
                          AND IDTIPOITMAPR = 'ED') LOOP

      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD('21'||V_POS_LINHA,10,'0'), TO_CHAR(V_POS_LINHA)||C_OUTROS_DEB.DSITEMMAPR||C_OUTROS_DEB.VRITEMMAPR, P_NRSEQARQMAG);
      V_POS_LINHA := NVL(V_POS_LINHA,0)+1;
   END LOOP;

   /* deducoes */
   V_POS_LINHA := 68;
   FOR C_OUTROS_DEB IN (SELECT LPAD(REPLACE(LTRIM(TO_CHAR(NVL(VRITEMMAPR,0), '999999999990.00')), '.', ''), 14, '0') AS VRITEMMAPR,
                               RPAD(SUBSTR(NVL(DSITEMMAPR,' '),1,30), 30, ' ') AS DSITEMMAPR
                        FROM ITMAPARECUP IT, MAPARECUP MR, MAPAAPURAC M
                        WHERE M.NRSEQUMAPAPU = MR.NRSEQUMAPAPU
                          AND MR.NRSEQUMAPAPU = IT.NRSEQUMAPAPU
                          AND M.CDEMPRESA = P_CDEMPRESA
                          AND M.CDINSCESTA = P_CDINSCESTA
                          AND M.DTINIPERIODO = P_DTINICIAL
                          AND M.DTFIMPERIODO = P_DTFINAL
                          AND M.CDIMPOSTO = P_CDIMPOSTO
                          AND IDTIPOITMAPR = 'DD') LOOP

      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (RPAD('21'||V_POS_LINHA,10,'0'), TO_CHAR(V_POS_LINHA)||C_OUTROS_DEB.DSITEMMAPR||C_OUTROS_DEB.VRITEMMAPR, P_NRSEQARQMAG);
      V_POS_LINHA := NVL(V_POS_LINHA,0)+1;
   END LOOP;

   /********************************************** comentrios *************************************************/
   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD('75',10,'0'), '75'||RPAD(' ',30,' '), P_NRSEQARQMAG);

   /* comentrios */
   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD('75',10,'0'), '75'||RPAD(' ',30,' '), P_NRSEQARQMAG);

   /* comentrios */
   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (RPAD('75',10,'0'), '75'||RPAD(' ',30,' '), P_NRSEQARQMAG);

   RETURN(LPAD(TO_CHAR(V_CONTADOR), 10, '0'));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_GIM_RN_20','5.05.024'); END;
/

